# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageDeploymentContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'org_id': 'str',
        'catalog_item_id': 'str',
        'catalog_item_version': 'str',
        'blueprint_id': 'str',
        'blueprint_version': 'str',
        'icon_id': 'str',
        'created_at': 'datetime',
        'created_by': 'str',
        'owned_by': 'str',
        'last_updated_at': 'datetime',
        'last_updated_by': 'str',
        'lease_expire_at': 'datetime',
        'lease_grace_period_days': 'int',
        'deleted': 'bool',
        'inputs': 'object',
        'project_id': 'str',
        'resources': 'list[DeploymentResources]',
        'project': 'CatalogItemType',
        'blueprint': 'CatalogItemType',
        'catalog': 'CatalogItemType',
        'last_request': 'DeploymentCurrentRequest',
        'inprogress_requests': 'object',
        'expense': 'DeploymentExpense',
        'status': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'org_id': 'orgId',
        'catalog_item_id': 'catalogItemId',
        'catalog_item_version': 'catalogItemVersion',
        'blueprint_id': 'blueprintId',
        'blueprint_version': 'blueprintVersion',
        'icon_id': 'iconId',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'owned_by': 'ownedBy',
        'last_updated_at': 'lastUpdatedAt',
        'last_updated_by': 'lastUpdatedBy',
        'lease_expire_at': 'leaseExpireAt',
        'lease_grace_period_days': 'leaseGracePeriodDays',
        'deleted': 'deleted',
        'inputs': 'inputs',
        'project_id': 'projectId',
        'resources': 'resources',
        'project': 'project',
        'blueprint': 'blueprint',
        'catalog': 'catalog',
        'last_request': 'lastRequest',
        'inprogress_requests': 'inprogressRequests',
        'expense': 'expense',
        'status': 'status'
    }

    def __init__(self, id=None, name=None, description=None, org_id=None, catalog_item_id=None, catalog_item_version=None, blueprint_id=None, blueprint_version=None, icon_id=None, created_at=None, created_by=None, owned_by=None, last_updated_at=None, last_updated_by=None, lease_expire_at=None, lease_grace_period_days=None, deleted=None, inputs=None, project_id=None, resources=None, project=None, blueprint=None, catalog=None, last_request=None, inprogress_requests=None, expense=None, status=None):  # noqa: E501
        """PageDeploymentContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._org_id = None
        self._catalog_item_id = None
        self._catalog_item_version = None
        self._blueprint_id = None
        self._blueprint_version = None
        self._icon_id = None
        self._created_at = None
        self._created_by = None
        self._owned_by = None
        self._last_updated_at = None
        self._last_updated_by = None
        self._lease_expire_at = None
        self._lease_grace_period_days = None
        self._deleted = None
        self._inputs = None
        self._project_id = None
        self._resources = None
        self._project = None
        self._blueprint = None
        self._catalog = None
        self._last_request = None
        self._inprogress_requests = None
        self._expense = None
        self._status = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        if org_id is not None:
            self.org_id = org_id
        if catalog_item_id is not None:
            self.catalog_item_id = catalog_item_id
        if catalog_item_version is not None:
            self.catalog_item_version = catalog_item_version
        if blueprint_id is not None:
            self.blueprint_id = blueprint_id
        if blueprint_version is not None:
            self.blueprint_version = blueprint_version
        if icon_id is not None:
            self.icon_id = icon_id
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if owned_by is not None:
            self.owned_by = owned_by
        if last_updated_at is not None:
            self.last_updated_at = last_updated_at
        if last_updated_by is not None:
            self.last_updated_by = last_updated_by
        if lease_expire_at is not None:
            self.lease_expire_at = lease_expire_at
        if lease_grace_period_days is not None:
            self.lease_grace_period_days = lease_grace_period_days
        if deleted is not None:
            self.deleted = deleted
        if inputs is not None:
            self.inputs = inputs
        if project_id is not None:
            self.project_id = project_id
        if resources is not None:
            self.resources = resources
        if project is not None:
            self.project = project
        if blueprint is not None:
            self.blueprint = blueprint
        if catalog is not None:
            self.catalog = catalog
        if last_request is not None:
            self.last_request = last_request
        if inprogress_requests is not None:
            self.inprogress_requests = inprogress_requests
        if expense is not None:
            self.expense = expense
        if status is not None:
            self.status = status

    @property
    def id(self):
        """Gets the id of this PageDeploymentContent.  # noqa: E501

        Id of the deployment  # noqa: E501

        :return: The id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageDeploymentContent.

        Id of the deployment  # noqa: E501

        :param id: The id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PageDeploymentContent.  # noqa: E501

        Name of the deployment  # noqa: E501

        :return: The name of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageDeploymentContent.

        Name of the deployment  # noqa: E501

        :param name: The name of this PageDeploymentContent.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this PageDeploymentContent.  # noqa: E501

        Description of the deployment  # noqa: E501

        :return: The description of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PageDeploymentContent.

        Description of the deployment  # noqa: E501

        :param description: The description of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def org_id(self):
        """Gets the org_id of this PageDeploymentContent.  # noqa: E501


        :return: The org_id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PageDeploymentContent.


        :param org_id: The org_id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def catalog_item_id(self):
        """Gets the catalog_item_id of this PageDeploymentContent.  # noqa: E501

        Deployment catalog item id  # noqa: E501

        :return: The catalog_item_id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._catalog_item_id

    @catalog_item_id.setter
    def catalog_item_id(self, catalog_item_id):
        """Sets the catalog_item_id of this PageDeploymentContent.

        Deployment catalog item id  # noqa: E501

        :param catalog_item_id: The catalog_item_id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._catalog_item_id = catalog_item_id

    @property
    def catalog_item_version(self):
        """Gets the catalog_item_version of this PageDeploymentContent.  # noqa: E501

        Deployment catalog version  # noqa: E501

        :return: The catalog_item_version of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._catalog_item_version

    @catalog_item_version.setter
    def catalog_item_version(self, catalog_item_version):
        """Sets the catalog_item_version of this PageDeploymentContent.

        Deployment catalog version  # noqa: E501

        :param catalog_item_version: The catalog_item_version of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._catalog_item_version = catalog_item_version

    @property
    def blueprint_id(self):
        """Gets the blueprint_id of this PageDeploymentContent.  # noqa: E501

        Deployment blueprint id  # noqa: E501

        :return: The blueprint_id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._blueprint_id

    @blueprint_id.setter
    def blueprint_id(self, blueprint_id):
        """Sets the blueprint_id of this PageDeploymentContent.

        Deployment blueprint id  # noqa: E501

        :param blueprint_id: The blueprint_id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._blueprint_id = blueprint_id

    @property
    def blueprint_version(self):
        """Gets the blueprint_version of this PageDeploymentContent.  # noqa: E501

        Deployment blueprint version  # noqa: E501

        :return: The blueprint_version of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._blueprint_version

    @blueprint_version.setter
    def blueprint_version(self, blueprint_version):
        """Sets the blueprint_version of this PageDeploymentContent.

        Deployment blueprint version  # noqa: E501

        :param blueprint_version: The blueprint_version of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._blueprint_version = blueprint_version

    @property
    def icon_id(self):
        """Gets the icon_id of this PageDeploymentContent.  # noqa: E501

        Deployment icon id  # noqa: E501

        :return: The icon_id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._icon_id

    @icon_id.setter
    def icon_id(self, icon_id):
        """Sets the icon_id of this PageDeploymentContent.

        Deployment icon id  # noqa: E501

        :param icon_id: The icon_id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._icon_id = icon_id

    @property
    def created_at(self):
        """Gets the created_at of this PageDeploymentContent.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this PageDeploymentContent.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PageDeploymentContent.

        Creation time  # noqa: E501

        :param created_at: The created_at of this PageDeploymentContent.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this PageDeploymentContent.  # noqa: E501

        Created by  # noqa: E501

        :return: The created_by of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PageDeploymentContent.

        Created by  # noqa: E501

        :param created_by: The created_by of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def owned_by(self):
        """Gets the owned_by of this PageDeploymentContent.  # noqa: E501

        Owned by  # noqa: E501

        :return: The owned_by of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._owned_by

    @owned_by.setter
    def owned_by(self, owned_by):
        """Sets the owned_by of this PageDeploymentContent.

        Owned by  # noqa: E501

        :param owned_by: The owned_by of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._owned_by = owned_by

    @property
    def last_updated_at(self):
        """Gets the last_updated_at of this PageDeploymentContent.  # noqa: E501

        Update time  # noqa: E501

        :return: The last_updated_at of this PageDeploymentContent.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_at

    @last_updated_at.setter
    def last_updated_at(self, last_updated_at):
        """Sets the last_updated_at of this PageDeploymentContent.

        Update time  # noqa: E501

        :param last_updated_at: The last_updated_at of this PageDeploymentContent.  # noqa: E501
        :type: datetime
        """

        self._last_updated_at = last_updated_at

    @property
    def last_updated_by(self):
        """Gets the last_updated_by of this PageDeploymentContent.  # noqa: E501

        Updated by  # noqa: E501

        :return: The last_updated_by of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, last_updated_by):
        """Sets the last_updated_by of this PageDeploymentContent.

        Updated by  # noqa: E501

        :param last_updated_by: The last_updated_by of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._last_updated_by = last_updated_by

    @property
    def lease_expire_at(self):
        """Gets the lease_expire_at of this PageDeploymentContent.  # noqa: E501

        Lease expiration time  # noqa: E501

        :return: The lease_expire_at of this PageDeploymentContent.  # noqa: E501
        :rtype: datetime
        """
        return self._lease_expire_at

    @lease_expire_at.setter
    def lease_expire_at(self, lease_expire_at):
        """Sets the lease_expire_at of this PageDeploymentContent.

        Lease expiration time  # noqa: E501

        :param lease_expire_at: The lease_expire_at of this PageDeploymentContent.  # noqa: E501
        :type: datetime
        """

        self._lease_expire_at = lease_expire_at

    @property
    def lease_grace_period_days(self):
        """Gets the lease_grace_period_days of this PageDeploymentContent.  # noqa: E501

        Deployment lease grace period before deletion in days  # noqa: E501

        :return: The lease_grace_period_days of this PageDeploymentContent.  # noqa: E501
        :rtype: int
        """
        return self._lease_grace_period_days

    @lease_grace_period_days.setter
    def lease_grace_period_days(self, lease_grace_period_days):
        """Sets the lease_grace_period_days of this PageDeploymentContent.

        Deployment lease grace period before deletion in days  # noqa: E501

        :param lease_grace_period_days: The lease_grace_period_days of this PageDeploymentContent.  # noqa: E501
        :type: int
        """

        self._lease_grace_period_days = lease_grace_period_days

    @property
    def deleted(self):
        """Gets the deleted of this PageDeploymentContent.  # noqa: E501

        Indicates whether the deployment is deleted or not.  # noqa: E501

        :return: The deleted of this PageDeploymentContent.  # noqa: E501
        :rtype: bool
        """
        return self._deleted

    @deleted.setter
    def deleted(self, deleted):
        """Sets the deleted of this PageDeploymentContent.

        Indicates whether the deployment is deleted or not.  # noqa: E501

        :param deleted: The deleted of this PageDeploymentContent.  # noqa: E501
        :type: bool
        """

        self._deleted = deleted

    @property
    def inputs(self):
        """Gets the inputs of this PageDeploymentContent.  # noqa: E501


        :return: The inputs of this PageDeploymentContent.  # noqa: E501
        :rtype: object
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this PageDeploymentContent.


        :param inputs: The inputs of this PageDeploymentContent.  # noqa: E501
        :type: object
        """

        self._inputs = inputs

    @property
    def project_id(self):
        """Gets the project_id of this PageDeploymentContent.  # noqa: E501

        Deployment project id  # noqa: E501

        :return: The project_id of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this PageDeploymentContent.

        Deployment project id  # noqa: E501

        :param project_id: The project_id of this PageDeploymentContent.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def resources(self):
        """Gets the resources of this PageDeploymentContent.  # noqa: E501

        Expanded resources for the deployment. Content of this property will not be maintained backward compatible  # noqa: E501

        :return: The resources of this PageDeploymentContent.  # noqa: E501
        :rtype: list[DeploymentResources]
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this PageDeploymentContent.

        Expanded resources for the deployment. Content of this property will not be maintained backward compatible  # noqa: E501

        :param resources: The resources of this PageDeploymentContent.  # noqa: E501
        :type: list[DeploymentResources]
        """

        self._resources = resources

    @property
    def project(self):
        """Gets the project of this PageDeploymentContent.  # noqa: E501


        :return: The project of this PageDeploymentContent.  # noqa: E501
        :rtype: CatalogItemType
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this PageDeploymentContent.


        :param project: The project of this PageDeploymentContent.  # noqa: E501
        :type: CatalogItemType
        """

        self._project = project

    @property
    def blueprint(self):
        """Gets the blueprint of this PageDeploymentContent.  # noqa: E501


        :return: The blueprint of this PageDeploymentContent.  # noqa: E501
        :rtype: CatalogItemType
        """
        return self._blueprint

    @blueprint.setter
    def blueprint(self, blueprint):
        """Sets the blueprint of this PageDeploymentContent.


        :param blueprint: The blueprint of this PageDeploymentContent.  # noqa: E501
        :type: CatalogItemType
        """

        self._blueprint = blueprint

    @property
    def catalog(self):
        """Gets the catalog of this PageDeploymentContent.  # noqa: E501


        :return: The catalog of this PageDeploymentContent.  # noqa: E501
        :rtype: CatalogItemType
        """
        return self._catalog

    @catalog.setter
    def catalog(self, catalog):
        """Sets the catalog of this PageDeploymentContent.


        :param catalog: The catalog of this PageDeploymentContent.  # noqa: E501
        :type: CatalogItemType
        """

        self._catalog = catalog

    @property
    def last_request(self):
        """Gets the last_request of this PageDeploymentContent.  # noqa: E501


        :return: The last_request of this PageDeploymentContent.  # noqa: E501
        :rtype: DeploymentCurrentRequest
        """
        return self._last_request

    @last_request.setter
    def last_request(self, last_request):
        """Sets the last_request of this PageDeploymentContent.


        :param last_request: The last_request of this PageDeploymentContent.  # noqa: E501
        :type: DeploymentCurrentRequest
        """

        self._last_request = last_request

    @property
    def inprogress_requests(self):
        """Gets the inprogress_requests of this PageDeploymentContent.  # noqa: E501


        :return: The inprogress_requests of this PageDeploymentContent.  # noqa: E501
        :rtype: object
        """
        return self._inprogress_requests

    @inprogress_requests.setter
    def inprogress_requests(self, inprogress_requests):
        """Sets the inprogress_requests of this PageDeploymentContent.


        :param inprogress_requests: The inprogress_requests of this PageDeploymentContent.  # noqa: E501
        :type: object
        """

        self._inprogress_requests = inprogress_requests

    @property
    def expense(self):
        """Gets the expense of this PageDeploymentContent.  # noqa: E501


        :return: The expense of this PageDeploymentContent.  # noqa: E501
        :rtype: DeploymentExpense
        """
        return self._expense

    @expense.setter
    def expense(self, expense):
        """Sets the expense of this PageDeploymentContent.


        :param expense: The expense of this PageDeploymentContent.  # noqa: E501
        :type: DeploymentExpense
        """

        self._expense = expense

    @property
    def status(self):
        """Gets the status of this PageDeploymentContent.  # noqa: E501

        Represents the status of deployment with respect to its life cycle operations - create/update/delete.  # noqa: E501

        :return: The status of this PageDeploymentContent.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PageDeploymentContent.

        Represents the status of deployment with respect to its life cycle operations - create/update/delete.  # noqa: E501

        :param status: The status of this PageDeploymentContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATE_SUCCESSFUL", "CREATE_INPROGRESS", "CREATE_FAILED", "UPDATE_SUCCESSFUL", "UPDATE_INPROGRESS", "UPDATE_FAILED", "DELETE_SUCCESSFUL", "DELETE_INPROGRESS", "DELETE_FAILED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageDeploymentContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageDeploymentContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
